<template>
  <pre>{{ rdfString }}</pre>
</template>

<script lang="ts">
import { serializeRDFDefinition } from "@/util/linkedData";
import factory from "rdf-ext";
import type { Dataset } from "@rdfjs/types";

import { defineComponent, type PropType } from "vue";

export default defineComponent({
  name: "MetadataView",
  props: {
    metadata: {
      default: () => factory.dataset() as unknown as Dataset,
      type: Object as PropType<Dataset>,
    },
  },
  data() {
    return {
      rdfString: "",
    };
  },
  watch: {
    metadata() {
      this.computeRdfString();
    },
  },
  mounted() {
    this.computeRdfString();
  },
  methods: {
    async computeRdfString() {
      this.rdfString = await serializeRDFDefinition(
        this.metadata,
        "text/turtle",
      );
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
pre {
  text-align: left;
}
</style>
